## rapiddisk 8.2.0

=== Makefile ===
# Copyright © 2016 - 2022 Petros Koutoupis
# All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

SUBDIRS = src conf doc module test

.PHONY: all
all: $(SUBDIRS)

.PHONY: $(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: clean
clean: $(SUBDIRS)

.PHONY: install
install: $(SUBDIRS)

.PHONY: uninstall
uninstall: $(SUBDIRS)

.PHONY: dkms-install
dkms-install:
	$(MAKE) -C module $@

.PHONY: dkms-uninstall
dkms-uninstall:
	$(MAKE) -C module $@

.PHONY: tools-install
tools-install:
	$(MAKE) -C src install
	$(MAKE) -C conf install
	$(MAKE) -C doc install

.PHONY: tools-uninstall
tools-uninstall:
	$(MAKE) -C src uninstall
	$(MAKE) -C conf uninstall
	$(MAKE) -C doc uninstall

=== conf/Makefile ===
# Copyright © 2016 - 2022 Petros Koutoupis
# All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

CP := cp
RM := rm -rf
MKDIR := mkdir -pv -m 755
SERVICE = rapiddisk
CFG_DIR := /etc/$(SERVICE)/
SYSD_DIR := /etc/systemd/system
CHMOD := chmod

.PHONY: all
all: 
	@echo Nothing to do.

.PHONY: install
install: all
	@echo Installing rapiddisk high availability and rapiddiskd daemon files.
	$(MKDIR) $(DESTDIR)$(CFG_DIR)
	$(CP) $(SERVICE).* $(DESTDIR)$(CFG_DIR)
	$(CHMOD) -R 755 $(DESTDIR)$(CFG_DIR)
	$(MKDIR) $(DESTDIR)$(SYSD_DIR)
	$(CP) $(SERVICE)d.* $(DESTDIR)$(SYSD_DIR)
	$(CHMOD) -R 755 $(DESTDIR)$(SYSD_DIR)

.PHONY: uninstall
uninstall: 
	@echo Uninstalling rapiddisk high availability and rapiddiskd daemon files.
	$(RM) $(DESTDIR)$(CFG_DIR)
	$(RM) $(DESTDIR)$(SYSD_DIR)/$(SERVICE)d.*

.PHONY: clean
clean:
	@echo Nothing to do.

=== doc/Makefile ===
# Copyright © 2016 - 2022 Petros Koutoupis
# All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

CP := cp
RM := rm -f
MKDIR := mkdir -pv -m 755
MAN_DIR := /usr/share/man/man1

.PHONY: all
all: 
	@echo Nothing to do.

.PHONY: install
install: all
	@echo Installing rapiddisk man pages.
	$(MKDIR) $(DESTDIR)$(MAN_DIR)
	$(CP) rapiddisk*.1 $(DESTDIR)$(MAN_DIR)/

.PHONY: uninstall
uninstall: 
	@echo Uninstalling rapiddisk man pages.
	$(RM) $(DESTDIR)$(MAN_DIR)/rapiddisk.1
	$(RM) $(DESTDIR)$(MAN_DIR)/rapiddiskd.1

.PHONY: clean
clean:
	@echo Nothing to do.

=== module/Makefile ===
# Copyright © 2011 - 2022 Petros Koutoupis
# All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; under version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-only

VERSION = 8.2.0

ifeq ($(KSRC),)
	KSRC := /lib/modules/$(shell uname -r)/build
endif

ifeq ($(KVER),)
	KVER := $(shell uname -r)
endif

MKDIR := mkdir -pv
CP := cp -v
DKMSFILES := rapiddisk.c rapiddisk-cache.c dkms.conf Makefile
DKMSDEST := /usr/src/rapiddisk-$(VERSION)

obj-m += rapiddisk.o
obj-m += rapiddisk-cache.o

all:
	$(MAKE) -C $(KSRC) M=$(CURDIR)

install: all
	$(MKDIR) $(DESTDIR)/lib/modules/$(KVER)/kernel/drivers/block/
	install -o root -g root -m 0755 rapiddisk.ko $(DESTDIR)/lib/modules/$(KVER)/kernel/drivers/block/
	install -o root -g root -m 0755 rapiddisk-cache.ko $(DESTDIR)/lib/modules/$(KVER)/kernel/drivers/block/
	depmod -a

uninstall:
	rm -f $(DESTDIR)/lib/modules/$(KVER)/kernel/drivers/block/rapiddisk.ko
	rm -f $(DESTDIR)/lib/modules/$(KVER)/kernel/drivers/block/rapiddisk-cache.ko
	depmod -a

clean:
	rm -rf *.o *.ko *.symvers *.mod.c .*.cmd Module.markers modules.order *.o.* built-in*
	rm -rf .tmp_versions .rapiddisk.o.d *.unsigned *.sdtinfo.c .ctf/ .cache.mk *.mod

dkms-install: clean uninstall
ifeq ($(shell which dkms >/dev/null 2>/dev/null; echo $$?),1)
	$(error No 'dkms' command found)
else ifeq ($(shell dkms status rapiddisk/$(VERSION) -k $(KVER) | grep '$(KVER)' >/dev/null 2>/dev/null; echo $$?),0)
	$(error rapiddisk version $(VERSION) is already installed for kernel $(KVER). Use 'make dkms-uninstall' first)
else
	dkms add . || true
	dkms install rapiddisk/$(VERSION) -k $(KVER)
endif

dkms-uninstall: clean uninstall
ifeq ($(shell which dkms >/dev/null 2>/dev/null; echo $$?),1)
	$(error No 'dkms' command found)
else ifeq ($(shell dkms status rapiddisk/$(VERSION) -k $(KVER) | grep '$(KVER)' >/dev/null 2>/dev/null; echo $$?),0)
	dkms remove rapiddisk/$(VERSION) -k $(KVER)
else
	$(error rapiddisk version $(VERSION) is not installed for kernel $(KVER))
endif

=== src/Makefile ===
# Copyright © 2011 - 2022 Petros Koutoupis
# All rights reserved.
#
# This file is part of RapidDisk.
#
# RapidDisk is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# RapidDisk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with RapidDisk.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

ifeq ($(CC),)
	CC := gcc -Werror
endif

CHMOD := chmod
CP := cp
RM := rm -f
MKDIR := mkdir -pv

BIN = rapiddisk
DIR := /sbin

.PHONY: all
all: $(BIN) $(BIN)d
	@echo Make has completed.

.PHONY: install
install: all
	@echo Installing all $(BIN) binary files.
	$(MKDIR) $(DESTDIR)$(DIR)
	$(CP) $(BIN)* $(DESTDIR)$(DIR)
	$(CHMOD) 755 $(DESTDIR)$(DIR)/$(BIN)
	$(CHMOD) 755 $(DESTDIR)$(DIR)/$(BIN)d

.PHONY: uninstall
uninstall:
	@echo Uninstalling $(BIN) binary files.
	$(RM) $(DESTDIR)$(DIR)/$(BIN)
	$(RM) $(DESTDIR)$(DIR)/$(BIN)d

json.o: json.c
	$(CC) -c json.c -o json.o

json-server.o: json.c
	$(CC) -c json.c -DSERVER -o json-server.o

net.o: net.c
	$(CC) -c net.c -o net.o

nvmet.o: nvmet.c
	$(CC) -c nvmet.c -o nvmet.o

rdsk.o: rdsk.c
	$(CC) -c rdsk.c -o rdsk.o

sys.o: sys.c
	$(CC) -c sys.c -o sys.o

sys-server.o: sys.c
	$(CC) -c sys.c -DSERVER -o sys-server.o

$(BIN): main.c json.o rdsk.o nvmet.o sys.o
	$(CC) main.c -o $(BIN) json.o nvmet.o rdsk.o sys.o -ljansson

$(BIN)d: daemon.c json-server.o net.o sys-server.o
	$(CC) daemon.c -o $(BIN)d json-server.o net.o sys-server.o -lpthread -ljansson -lmicrohttpd

.PHONY: clean
clean:
	rm -f *.o $(BIN) $(BIN)d

=== test/Makefile ===
# Copyright © 2016 - 2022 Petros Koutoupis
# All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

ifeq ($(CC),)
	CC := gcc -Werror
endif

BIN = rxflush rxio rxioctl

.PHONY: all
all: $(BIN)
	@echo Make has completed.

.PHONY: install
install: all
	@echo Nothing to do.

.PHONY: uninstall
uninstall:
	@echo Nothing to do.

rxflush: rxflush.c
	$(CC) rxflush.c -o rxflush

rxio: rxio.c
	$(CC) rxio.c -o rxio

rxioctl: rxioctl.c
	$(CC) rxioctl.c -o rxioctl

.PHONY: clean
clean:
	rm -f $(BIN)

=== debian/changelog ===
rapiddisk (8.2.0-2ubuntu1) kinetic; urgency=medium

  * Support Linux 5.19 (LP: #1983561):
    - debian/patches/0001-Support-linux-5.19.patch

 -- Andrea Righi <andrea.righi@canonical.com>  Thu, 04 Aug 2022 08:08:48 +0000

rapiddisk (8.2.0-2) unstable; urgency=medium

  * Source upload.

 -- Gürkan Myczko <tar@debian.org>  Mon, 25 Jul 2022 09:55:33 +0200

rapiddisk (8.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Gürkan Myczko <tar@debian.org>  Tue, 21 Jun 2022 10:17:26 +0200

rapiddisk (8.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1013110)

 -- Gürkan Myczko <tar@debian.org>  Thu, 16 Jun 2022 09:33:21 +0200

=== debian/control ===
Source: rapiddisk
Section: kernel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dkms,
 dh-dkms,
 libjansson-dev,
 libmicrohttpd-dev
Standards-Version: 4.6.1
Homepage: https://github.com/pkoutoupis/rapiddisk
Vcs-Browser: https://salsa.debian.org/debian/rapiddisk
Vcs-Git: https://salsa.debian.org/debian/rapiddisk.git

Package: rapiddisk-dkms
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Linux RAM Drive and Caching kernel modules (DKMS)
 This software defined advanced RAM drive and storage
 caching solution. This suite includes a collection of modules,
 configuration files, and command line utilities for managing
 RapidDisk enabled storage volumes and accessing them either
 locally or across an NVMe Target network.
 .
 This is the kernel module for Linux.

Package: rapiddisk
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Linux RAM Drive and Caching kernel modules
 This software defined advanced RAM drive and storage
 caching solution. This suite includes a collection of modules,
 configuration files, and command line utilities for managing
 RapidDisk enabled storage volumes and accessing them either
 locally or across an NVMe Target network.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/pkg-info.mk

pdkms:=rapiddisk-dkms
sname:=rapiddisk

%:
	dh $@ --with dkms

override_dh_auto_build:
	$(MAKE) -C src

override_dh_auto_install:
	@echo MOO
#	$(MAKE) tools-install
#	dh_auto_install
#	-rm debian/tmp/lib/modules/*/kernel/drivers/block/rapiddisk*.ko

override_dh_dkms:
	dh_install module/* usr/src/$(sname)-$(DEB_VERSION)
	dh_dkms -V $(DEB_VERSION)

## rapiddisk 9.0.0

=== doc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2022 Petros Koutoupis
+# Copyright © 2016 - 2023 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify
@@ -37,6 +37,5 @@
 	$(RM) $(DESTDIR)$(MAN_DIR)/rapiddisk.1
 	$(RM) $(DESTDIR)$(MAN_DIR)/rapiddiskd.1
 
-.PHONY: clean
-clean:
-	@echo Nothing to do.
+.PHONY: clean install-strip debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools dkms-uninstall dkms-install
+clean install-strip debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools dkms-uninstall dkms-install:

=== module/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2011 - 2022 Petros Koutoupis
+# Copyright © 2011 - 2023 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify
@@ -15,7 +15,7 @@
 #
 # SPDX-License-Identifier: GPL-2.0-only
 
-VERSION = 8.2.0
+VERSION = 9.0.0
 
 ifeq ($(KSRC),)
 	KSRC := /lib/modules/$(shell uname -r)/build
@@ -49,7 +49,7 @@
 
 clean:
 	rm -rf *.o *.ko *.symvers *.mod.c .*.cmd Module.markers modules.order *.o.* built-in*
-	rm -rf .tmp_versions .rapiddisk.o.d *.unsigned *.sdtinfo.c .ctf/ .cache.mk *.mod
+	rm -rf .tmp_versions .rapiddisk.o.d .rapiddisk-cache.o.d *.unsigned *.sdtinfo.c .ctf/ .cache.mk *.mod
 
 dkms-install: clean uninstall
 ifeq ($(shell which dkms >/dev/null 2>/dev/null; echo $$?),1)
@@ -69,3 +69,9 @@
 else
 	$(error rapiddisk version $(VERSION) is not installed for kernel $(KVER))
 endif
+
+.PHONY: test
+run-test: all
+
+.PHONY: install-strip debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools
+install-strip debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools:

=== src/Makefile ===
# Copyright © 2011 - 2023 Petros Koutoupis
# All rights reserved.
#
# This file is part of RapidDisk.
#
# RapidDisk is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# RapidDisk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with RapidDisk.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

ifeq ($(CC),)
	CC := gcc -Werror
endif

RM := rm -f
STRIP_CMD := strip -s
DIR := /sbin
DAEMON_CFLAGS := -DSERVER
INSTALL := install -D -m 755 -t $(DESTDIR)$(DIR)
INSTALL_STRIP := install -D -m 755 -s -t $(DESTDIR)$(DIR)
DEBUG_FLAGS := -DDEBUG -Wl,--export-dynamic -g $(CFLAGS)
DEBUG_LDFLAGS := -DDEBUG -Wl,--export-dynamic -g $(LDFLAGS)
ifndef CFLAGS
NDEBUG_CFLAGS := -O2 -Wno-unused-result -flto=auto -ffat-lto-objects -fstack-protector-strong
else
NDEBUG_CFLAGS := -O2 -Wno-unused-result -flto=auto -ffat-lto-objects -fstack-protector-strong $(CFLAGS)
endif
ifndef LDLIBS
COMMON_LDLIBS := -ljansson -ldevmapper -lpcre2-8
DAEMON_LDLIBS := -ljansson -ldevmapper -lpcre2-8 -lmicrohttpd
else
COMMON_LDLIBS := $(LDLIBS)
DAEMON_LDLIBS := $(LDLIBS)
endif
ifndef LDFLAGS
NDEBUG_LDFLAGS := -Wl,-Bsymbolic-functions -flto=auto -ffat-lto-objects -flto=auto -Wl,-z,relro
else
NDEBUG_LDFLAGS := -Wl,-Bsymbolic-functions -flto=auto -ffat-lto-objects -flto=auto -Wl,-z,relro $(LDFLAGS)
endif
ifndef CPPFLAGS
NDEBUG_CPPFLAGS := -Wdate-time
else
NDEBUG_CPPFLAGS := -Wdate-time $(CPPFLAGS)
endif
BIN_TOOL_NDEBUG := rapiddisk
BIN_DAEMON_NDEBUG := rapiddiskd
BIN_TOOL_DEBUG := rapiddisk_debug
BIN_DAEMON_DEBUG := rapiddiskd_debug
OBJS_TOOL_NDEBUG := main_ndebug.o utils_ndebug.o json_ndebug.o rdsk_ndebug.o nvmet_ndebug.o sys_ndebug.o
OBJS_DAEMON_NDEBUG := rapiddiskd_ndebug.o utils-server_ndebug.o json-server_ndebug.o nvmet-server_ndebug.o net_ndebug.o rdsk-server_ndebug.o sys-server_ndebug.o
OBJS_TOOL_DEBUG := main_debug.o utils_debug.o json_debug.o nvmet_debug.o rdsk_debug.o sys_debug.o
OBJS_DAEMON_DEBUG := rapiddiskd_debug.o utils-server_debug.o json-server_debug.o nvmet-server_debug.o net_debug.o rdsk-server_debug.o sys-server_debug.o
SRC := json.c main.c net.c nvmet.c rapiddiskd.c rdsk.c sys.c utils.c

.PHONY: all
all: $(BIN_TOOL_NDEBUG) $(BIN_DAEMON_NDEBUG)
	@echo Successfully built all $(BIN_TOOL_NDEBUG) and $(BIN_DAEMON_NDEBUG) binary files.

# This checks avoid creating/including the .h dependencies Makefiles
# Disables parallelization if "clean" is present in the goal list
ifneq (,$(filter clean,$(MAKECMDGOALS)))
ifneq (1, $(words $(MAKECMDGOALS)))
.NOTPARALLEL:
endif
else
include $(SRC:.c=.d)
endif

.PHONY: clean
clean:
	rm -f *.d $(OBJS_TOOL_NDEBUG) $(OBJS_DAEMON_NDEBUG) $(OBJS_TOOL_DEBUG) $(OBJS_DAEMON_DEBUG) $(BIN_TOOL_NDEBUG) $(BIN_DAEMON_NDEBUG) $(BIN_TOOL_DEBUG) $(BIN_DAEMON_DEBUG)
    MAKECMDGOALS:=$(filter-out clean,$(MAKECMDGOALS)))

.PHONY: tools
tools: all

.PHONY: run-test
run-test: all debug

.PHONY: clean-tools
clean-tools: clean

.PHONY: tools-install
tools-install: install

.PHONY: debug
debug: $(BIN_TOOL_DEBUG) $(BIN_DAEMON_DEBUG)

.PHONY: tools-debug
tools-debug: debug

.PHONY: strip
strip: tools-strip

.PHONY: tools-strip
tools-strip: all
	$(STRIP_CMD) $(BIN_TOOL_NDEBUG)
	$(STRIP_CMD) $(BIN_DAEMON_NDEBUG)

.PHONY: install
install: all
	@echo Installing all $(BIN_TOOL_NDEBUG) and $(BIN_DAEMON_NDEBUG) binary files.
	$(INSTALL) $(BIN_TOOL_NDEBUG) $(BIN_DAEMON_NDEBUG)

.PHONY: install-strip
install-strip: tools-install-strip

.PHONY: tools-install-strip
tools-install-strip: all
	@echo Installing stripped $(BIN_TOOL_NDEBUG) and $(BIN_DAEMON_NDEBUG) binary files.
	$(INSTALL_STRIP) $(BIN_TOOL_NDEBUG) $(BIN_DAEMON_NDEBUG)

.PHONY: uninstall
uninstall:
	@echo Uninstalling $(BIN_TOOL_NDEBUG) and $(BIN_DAEMON_NDEBUG) binary files.
	$(RM) $(DESTDIR)$(DIR)/$(BIN_TOOL_NDEBUG)
	$(RM) $(DESTDIR)$(DIR)/$(BIN_DAEMON_NDEBUG)

.PHONY: tools-uninstall
tools-uninstall: uninstall

%_debug.o: override CFLAGS += $(DEBUG_FLAGS)
%_debug.o: %.c %.d
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

%-server_debug.o: %.c %.d
	$(CC) $(CPPFLAGS) $(DAEMON_CFLAGS) $(CFLAGS) -c $< -o $@

%_ndebug.o: CFLAGS = $(NDEBUG_CFLAGS)
%_ndebug.o: CPPFLAGS = $(NDEBUG_CPPFLAGS)
%_ndebug.o : %.c %.d
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

%-server_ndebug.o: %.c %.d
	$(CC) $(CPPFLAGS) $(DAEMON_CFLAGS) $(CFLAGS) -c $< -o $@

$(BIN_TOOL_NDEBUG): LDLIBS = $(COMMON_LDLIBS)
$(BIN_TOOL_NDEBUG): LDFLAGS = $(NDEBUG_LDFLAGS)
$(BIN_TOOL_NDEBUG): $(OBJS_TOOL_NDEBUG)
	$(CC) $(LDFLAGS) -o $(BIN_TOOL_NDEBUG) $(OBJS_TOOL_NDEBUG) $(LOADLIBES) $(LDLIBS)

$(BIN_DAEMON_NDEBUG): LDLIBS = $(DAEMON_LDLIBS)
$(BIN_DAEMON_NDEBUG): LDFLAGS = $(NDEBUG_LDFLAGS)
$(BIN_DAEMON_NDEBUG): $(OBJS_DAEMON_NDEBUG)
	$(CC) $(LDFLAGS) -o $(BIN_DAEMON_NDEBUG) $(OBJS_DAEMON_NDEBUG) $(LOADLIBES) $(LDLIBS)

$(BIN_TOOL_DEBUG): override LDFLAGS += $(DEBUG_LDFLAGS)
$(BIN_TOOL_DEBUG): override LDLIBS += $(COMMON_LDLIBS)
$(BIN_TOOL_DEBUG): $(OBJS_TOOL_DEBUG)
	$(CC) $(LDFLAGS) -o $(BIN_TOOL_DEBUG) $(OBJS_TOOL_DEBUG) $(LOADLIBES) $(LDLIBS)

$(BIN_DAEMON_DEBUG): override LDFLAGS = $(DEBUG_LDFLAGS)
$(BIN_DAEMON_DEBUG): override LDLIBS = $(DAEMON_LDLIBS)
$(BIN_DAEMON_DEBUG): $(OBJS_DAEMON_DEBUG)
	$(CC) $(LDFLAGS) -o $(BIN_DAEMON_DEBUG) $(OBJS_DAEMON_DEBUG) $(LOADLIBES) $(LDLIBS)

.PHONY: tools-clean
tools-clean: clean

.PHONY: dkms-uninstall dkms-install
dkms-uninstall dkms-install:

%.d: %.c
    ifeq (,$(filter clean,$(MAKECMDGOALS)))
	@echo Creating Makefile $@
	@set -e; rm -f $@; \
	$(CC) -MM $(CPPFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,\1_ndebug.o \1_debug.o \1\.d : ,g' < $@.$$$$ > $@; \
	rm -f $@.$$$$; \
	$(CC) -MM $(DAEMON_CFLAGS) $(CPPFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,\1-server_ndebug\.o \1-server_debug\.o \1\.d : ,g' < $@.$$$$ >> $@; \
	rm -f $@.$$$$
    endif

%.c:

=== test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2022 Petros Koutoupis
+# Copyright © 2016 - 2023 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify
@@ -20,29 +20,19 @@
 	CC := gcc -Werror
 endif
 
-BIN = rxflush rxio rxioctl
+BIN = rxflush rxio rxioctl rxro
 
 .PHONY: all
 all: $(BIN)
-	@echo Make has completed.
 
-.PHONY: install
-install: all
-	@echo Nothing to do.
-
-.PHONY: uninstall
-uninstall:
-	@echo Nothing to do.
-
-rxflush: rxflush.c
-	$(CC) rxflush.c -o rxflush
-
-rxio: rxio.c
-	$(CC) rxio.c -o rxio
-
-rxioctl: rxioctl.c
-	$(CC) rxioctl.c -o rxioctl
+.PHONY: run-test
+run-test: all
+	./test-leaks.sh
+	./cache-test.sh
 
 .PHONY: clean
 clean:
 	rm -f $(BIN)
+
+.PHONY: install install-strip uninstall debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools dkms-uninstall dkms-install
+install install-strip uninstall debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools dkms-uninstall dkms-install:

=== debian/changelog ===
rapiddisk (9.0.0-1+deb12u1) bookworm; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #1091209)
  * Drop unused obsolete patches.
  * Cherry-pick upstream commits for supporting up to Linux 6.10.
    (Closes: #1069945, #1070418)
  * dkms.conf: Set BUILD_EXCLUSIVE_KERNEL_MIN="2.6.39" for using kstrto*().
  * Upload to bookworm.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 05 Feb 2025 16:18:20 +0100

rapiddisk (9.0.0-1) unstable; urgency=medium

  * New upstream version.
  * Thanks/Ack Andreas Beckmann, Andrea Rigi for the previous changes,
    disabled the debian/patches as upstreamed.
  * d/copyright: bump years.
  * d/control: add libdevmapper-dev to build-depends.
  * Bump standards version to 4.6.2.

 -- Gürkan Myczko <tar@debian.org>  Fri, 03 Feb 2023 07:45:15 +0100

rapiddisk (8.2.0-4.1) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Non-maintainer upload.
  * Switch to dh-sequence-dkms. (Closes: #1027882)
  * Declare Testsuite: autopkgtest-pkg-dkms.

  [ Andrea Righi ]
  * Support linux 6.x. (Closes: #1029266)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 31 Jan 2023 14:28:59 +0100

rapiddisk (8.2.0-4) unstable; urgency=medium

  * Really stop double shipping of conflicting files. (Closes: #1016508)
  * Apply patch from Andreas Righi to build on 5.19.x kernels. Thanks.

 -- Gürkan Myczko <tar@debian.org>  Wed, 14 Sep 2022 09:57:07 +0200

rapiddisk (8.2.0-3) unstable; urgency=medium

  * Stop double shipping of same files, only use upstream version.
    (Closes: #1016508)

 -- Gürkan Myczko <tar@debian.org>  Tue, 16 Aug 2022 15:16:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: rapiddisk
 Section: kernel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- dkms,
- dh-dkms,
+ dh-sequence-dkms,
+ libdevmapper-dev,
  libjansson-dev,
  libmicrohttpd-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/pkoutoupis/rapiddisk
 Vcs-Browser: https://salsa.debian.org/debian/rapiddisk
 Vcs-Git: https://salsa.debian.org/debian/rapiddisk.git
+Testsuite: autopkgtest-pkg-dkms
 
 Package: rapiddisk-dkms
 Architecture: all

=== debian/watch ===
version=4
# GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/pkoutoupis/rapiddisk/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## rapiddisk 9.1.0

=== Makefile ===
# Copyright © 2016 - 2023 Petros Koutoupis
# All rights reserved.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-License-Identifier: GPL-2.0-or-later

MODULE_SUBDIR = module
TEST_SUBDIR = test
TOOLS_SUBDIR = src
CONF_SUBDIRS = conf doc

.PHONY: all
all: $(MODULE_SUBDIR) $(TOOLS_SUBDIR) $(TEST_SUBDIR)

.PHONY: $(MODULE_SUBDIR)
$(MODULE_SUBDIR):
	$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: $(TEST_SUBDIR)
$(TEST_SUBDIR):
	$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: $(TOOLS_SUBDIR)
$(TOOLS_SUBDIR):
	$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: $(CONF_SUBDIRS)
$(CONF_SUBDIRS):
	$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: clean
clean: $(MODULE_SUBDIR) $(TOOLS_SUBDIR) $(TEST_SUBDIR)

.PHONY: run-test
run-test: $(MODULE_SUBDIR) $(TOOLS_SUBDIR) $(TEST_SUBDIR)

.PHONY: install
install: $(MODULE_SUBDIR) $(TOOLS_SUBDIR) $(CONF_SUBDIRS)

.PHONY: install-strip
install-strip: MAKECMDGOALS=install
install-strip: install
	$(MAKE) -C $(TOOLS_SUBDIR) install-strip

.PHONY: uninstall
uninstall: $(MODULE_SUBDIR) $(TOOLS_SUBDIR) $(CONF_SUBDIRS)

.PHONY: dkms-install
dkms-install: $(MODULE_SUBDIR)

.PHONY: dkms-uninstall
dkms-uninstall: $(MODULE_SUBDIR)

.PHONY: tools
tools: $(TOOLS_SUBDIR)

.PHONY: clean-tools
clean-tools: $(TOOLS_SUBDIR)

.PHONY: tools-install
tools-install: $(TOOLS_SUBDIR)

.PHONY: tools-install-strip
tools-install-strip: $(TOOLS_SUBDIR)

.PHONY: tools-uninstall
tools-uninstall: $(TOOLS_SUBDIR)

.PHONY: tools-debug
tools-debug: $(TOOLS_SUBDIR)

.PHONY: tools-strip
tools-strip: $(TOOLS_SUBDIR)

.PHONY: debug
debug: tools-debug

=== conf/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2022 Petros Koutoupis
+# Copyright © 2016 - 2023 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify
@@ -23,6 +23,7 @@
 CFG_DIR := /etc/$(SERVICE)/
 SYSD_DIR := /etc/systemd/system
 CHMOD := chmod
+INSTALL := install -D -m 755 -t
 
 .PHONY: all
 all: 
@@ -31,12 +32,9 @@
 .PHONY: install
 install: all
 	@echo Installing rapiddisk high availability and rapiddiskd daemon files.
-	$(MKDIR) $(DESTDIR)$(CFG_DIR)
-	$(CP) $(SERVICE).* $(DESTDIR)$(CFG_DIR)
-	$(CHMOD) -R 755 $(DESTDIR)$(CFG_DIR)
-	$(MKDIR) $(DESTDIR)$(SYSD_DIR)
-	$(CP) $(SERVICE)d.* $(DESTDIR)$(SYSD_DIR)
-	$(CHMOD) -R 755 $(DESTDIR)$(SYSD_DIR)
+	$(INSTALL) $(DESTDIR)$(CFG_DIR) $(SERVICE).*
+	$(INSTALL) $(DESTDIR)$(SYSD_DIR) $(SERVICE)d.*
+
 
 .PHONY: uninstall
 uninstall: 
@@ -44,6 +42,5 @@
 	$(RM) $(DESTDIR)$(CFG_DIR)
 	$(RM) $(DESTDIR)$(SYSD_DIR)/$(SERVICE)d.*
 
-.PHONY: clean
-clean:
-	@echo Nothing to do.
+.PHONY: clean install-strip debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools dkms-uninstall dkms-install
+clean install-strip debug tools-strip tools-debug tools-uninstall tools-install-strip tools-install clean-tools tools dkms-uninstall dkms-install:

=== module/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 # SPDX-License-Identifier: GPL-2.0-only
 
-VERSION = 9.0.0
+VERSION = 9.1.0
 
 ifeq ($(KSRC),)
 	KSRC := /lib/modules/$(shell uname -r)/build

=== debian/changelog ===
rapiddisk (9.1.0-5) unstable; urgency=medium

  * QA upload.

  [ Paolo Pisati ]
  * Fix FTBFS with Linux 6.11.  (Closes: #1093127)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 05 Feb 2025 15:33:57 +0100

rapiddisk (9.1.0-4) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #1091209)
  * Drop unused obsolete patches.
  * Drop -dkms suffix from dkms module name.
  * Use dkms.conf from upstream.
  * Do not ship an executable .service file.
  * Simplify debian/rules.
  * Cherry-pick upstream commits for supporting up to Linux 6.10.
    (Closes: #1069945, #1070418)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 15 Jan 2025 14:06:14 +0100

rapiddisk (9.1.0-3) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/rapiddisk.install: update path. (Closes: #1073655)

 -- Alex Myczko <tar@debian.org>  Mon, 22 Jul 2024 13:57:51 +0000

rapiddisk (9.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <tar@debian.org>  Tue, 13 Jun 2023 16:23:57 +0200

rapiddisk (9.1.0-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Tue, 25 Apr 2023 10:23:46 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  libdevmapper-dev,
  libjansson-dev,
  libmicrohttpd-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/pkoutoupis/rapiddisk
 Vcs-Browser: https://salsa.debian.org/debian/rapiddisk
 Vcs-Git: https://salsa.debian.org/debian/rapiddisk.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

include /usr/share/dpkg/pkg-info.mk


%:
	dh $@ --sourcedirectory=src

# the upstream install target *silently* breaks without failing
# if INSTALL is overridden by dh_*
override_dh_auto_install:

execute_after_dh_install-indep:
	dh_install -prapiddisk-dkms module/Makefile module/*.c usr/src/rapiddisk-$(DEB_VERSION_UPSTREAM)

execute_before_dh_fixperms-arch:
	chmod -x debian/rapiddisk/usr/lib/systemd/system/rapiddiskd.service

## rapiddisk 9.2.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2023 Petros Koutoupis
+# Copyright © 2016 - 2025 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify

=== conf/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2023 Petros Koutoupis
+# Copyright © 2016 - 2025 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify

=== doc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2023 Petros Koutoupis
+# Copyright © 2016 - 2025 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify

=== module/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2011 - 2023 Petros Koutoupis
+# Copyright © 2011 - 2025 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify
@@ -15,7 +15,7 @@
 #
 # SPDX-License-Identifier: GPL-2.0-only
 
-VERSION = 9.1.0
+VERSION = 9.2.0
 
 ifeq ($(KSRC),)
 	KSRC := /lib/modules/$(shell uname -r)/build

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2011 - 2023 Petros Koutoupis
+# Copyright © 2011 - 2025 Petros Koutoupis
 # All rights reserved.
 #
 # This file is part of RapidDisk.
@@ -36,8 +36,8 @@
 NDEBUG_CFLAGS := -O2 -Wno-unused-result -flto=auto -ffat-lto-objects -fstack-protector-strong $(CFLAGS)
 endif
 ifndef LDLIBS
-COMMON_LDLIBS := -ljansson -ldevmapper -lpcre2-8
-DAEMON_LDLIBS := -ljansson -ldevmapper -lpcre2-8 -lmicrohttpd
+COMMON_LDLIBS := -ljansson -ldevmapper -lpcre2-8 -lm
+DAEMON_LDLIBS := -ljansson -ldevmapper -lpcre2-8 -lmicrohttpd -lm
 else
 COMMON_LDLIBS := $(LDLIBS)
 DAEMON_LDLIBS := $(LDLIBS)

=== test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright © 2016 - 2023 Petros Koutoupis
+# Copyright © 2016 - 2025 Petros Koutoupis
 # All rights reserved.
 #
 # This program is free software: you can redistribute it and/or modify

=== debian/changelog ===
rapiddisk (9.2.0-2~25.10.1) questing; urgency=medium

  * Support 6.17 kernel (LP: #2134569)
    - No change backport from Resolute to ensure it sorts before -devel version

 -- John Cabaj <john.cabaj@canonical.com>  Fri, 19 Dec 2025 22:02:30 +0100

rapiddisk (9.2.0-2) unstable; urgency=medium

  * QA upload.
  * Fix module build for Linux 6.16.  (Closes: #1109903)
  * Fix building with -std=c23.  (Closes: #1097769)
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Dec 2025 13:03:38 +0100

rapiddisk (9.2.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Bump standards version to 4.7.2.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 17 Mar 2025 01:03:37 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: rapiddisk
 Section: kernel
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Rules-Requires-Root: no
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-dkms,
  libdevmapper-dev,
  libjansson-dev,
  libmicrohttpd-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/pkoutoupis/rapiddisk
 Vcs-Browser: https://salsa.debian.org/debian/rapiddisk
 Vcs-Git: https://salsa.debian.org/debian/rapiddisk.git
